# Primitives

Utililties functions for primitives types :

- `option`
- `string`
- `array`

## Option

### string

- `fromString` : `string => option(string)`
- `toString` : `option(string) => string`

```rescript
let anEmptyString = "";

Toolkit.Primitives.Option.fromString(anEmptyString)
->Option.map(v => v ++ "test");

Toolkit.Primitives.Option.toString(Some("test")); // "test"
Toolkit.Primitives.Option.toString(None); // ""
```

### boolean

- `fromBool` : `bool => option(bool)`

```rescript
Toolkit.Primitives.Option.fromBool(true); // Some(true)
Toolkit.Primitives.Option.fromBool(false); // None
```

## Array

```rescript
let variable = ["abc", "dce", ""];

Js.log(Primitives.Array.joinNonEmpty(anEmptyString)); // "abc, dce"
Js.log(Primitives.Array.joinNonEmpty(~separator="+", anEmptyString)); // "abc+dce"
Js.log(variable->Primitives.Array.tail); // ""
```

## Result

```rescript
let result = Ok("test");
let test = Error("error");

Js.log(Primitives.Result.get(result)); // Some("test")
Js.log(Primitives.Result.get(test)); // None
```
